require 'uu/os/application/abstract_controller'
require 'uu/os/util/application_container_service'
require 'forwardable'

module UU
  module OS
    module Util

      # Service providing system information of running module.
      # @private
        class ContainerService < UU::OS::Application::AbstractController # :nodoc:
        extend Forwardable

        # Service path.
        # @private
        CONTROLLER_URL_PATH = '_uu_' # :nodoc:

        # @private
        @@delegators = {}

        # Stores invocation time to thread.
        # @private
        def service(request) # :nodoc:
          Thread.current[:start] = Time.now
          super(request)
        end

        def self.register_service(obj, *methods)
          return if obj.nil?
          class_name = obj.class.to_s.tr(':','').to_sym
          @@delegators[class_name.to_sym] = obj
          def_delegators("@@delegators[:#{class_name}]".to_sym, *methods)
        end

        register_service(UU::OS::Util::ApplicationContainerService.new, :on_health, :on_status)
      end

    end
  end
end
